
#include <stdlib.h>
#include <string.h>

// Basic function to escape a HTML string
// Inspired by an example in https://cwe.mitre.org/data/definitions/122.html
char *escapeHtml(char *htmlStr){
  int len = strlen(htmlStr);
  char *escapedHtml = (char*) malloc(len * 3);
  char* out = escapedHtml;
  for (const char* p = htmlStr; *p != '\0'; p++) {
    char* escapeSeq = NULL;
    switch(*p) {
      case '&':
        escapeSeq = "&amp;"; break;	
      case '<':
        escapeSeq = "&lt;"; break;	
      case '>':
        escapeSeq = "&gt;"; break;	
    }
    if (escapeSeq != NULL) {
      for (char* p2 = escapeSeq; *p2 != '\0'; p2++) {
        *out = *p2;
        ++out;	
      }
    } else {
      *out = *p;
      out++; 
    }
  }
  *out = 0;
  return escapedHtml;
}

