#! /bin/bash
N=1000
crashes=0
echo Fuzzing, please wait ...
for i in $(seq 1 1000)
do
   radamsa -s "$i" seeds/example.html > tmp.html
   ./escapeProg tmp.html > /dev/null
   if [ $? -ne 0 ]; then
      cp tmp.html crash-radamsa-$i.html; rm tmp.html
      echo Got a crash with seed $i - check crash-radamsa-$i.html
      crashes=$((crashes + 1))
   fi
done
echo Done ... $crashes program crashes in $N executions
rm tmp.html
